commit 641f1f445b9bc4f95dfe9cc2f3fb816f24e7e546
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Jul 29 00:59:40 2024 +0530

    PS-9301 Double processing of FTS index words with innodb_optimize_fulltext_only
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#34929814 mysql/mysql-server@66cc7556964
    
    Symptom:
    When running OPTIMIZE TABLE on a table with FTS index with
    innodb_optimize_fulltext_only option enabled, the last word to be
    processed is very rarely and apparently randomly processed twice.
    
    Root cause:
    When zlib uncompressed the end of a compressed stream, inflate() will
    either return Z_STREAM_END, or it will return Z_OK, in which case the
    subsequent call will output 0 bytes and return Z_STREAM_END.
    fts_zip_read_word function handles the first case correctly, but in the
    second the behavior is incorrect: on the call, where Z_STREAM_END is
    returned from inflate(), fts_zip_read_word returns true without actually
    touching the word buffer. When this happens, the caller interprets this
    as the function having read the same word as it read on the previous
    call, and processes that word again.
    
    Fix:
    Change the logic of the function to return false if inflate() returns
    Z_STREAM_END without reading any bytes. refactor to make explicit the
    various states when reading a word from the compressed stream.
    
    Change-Id: Ib777a03b5dac0fc8bda2022b0342177f1c7d2e4a

diff --git a/mysql-test/suite/innodb_fts/r/optimize_big.result b/mysql-test/suite/innodb_fts/r/optimize_big.result
new file mode 100644
index 00000000000..d320d667c97
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/r/optimize_big.result
@@ -0,0 +1,168 @@
+SET GLOBAL innodb_optimize_fulltext_only=ON;
+CREATE TABLE book (
+id INT UNSIGNED AUTO_INCREMENT NOT NULL PRIMARY KEY,
+heading VARCHAR(20),
+content TEXT,
+FULLTEXT idx (content)
+) ENGINE= InnoDB DEFAULT CHARSET=utf8mb4;
+CREATE PROCEDURE find (word CHAR(20))
+SELECT heading FROM book WHERE MATCH(content)
+AGAINST (word IN NATURAL LANGUAGE MODE)
+ORDER BY id;
+LOAD DATA INFILE '<MYSQLTEST_VARDIR>/std_data/lob/frankenstein.txt' INTO TABLE book CHARACTER SET utf8mb4
+FIELDS TERMINATED BY '#' LINES TERMINATED BY '@' (heading, content);
+CALL find('they');
+heading
+?Letter 1
+Letter 2
+Letter 4
+Chapter 1
+Chapter 2
+Chapter 3
+Chapter 5
+Chapter 6
+Chapter 7
+Chapter 8
+Chapter 9
+Chapter 10
+Chapter 11
+Chapter 12
+Chapter 13
+Chapter 14
+Chapter 15
+Chapter 16
+Chapter 17
+Chapter 18
+Chapter 19
+Chapter 20
+Chapter 21
+Chapter 22
+Chapter 23
+Chapter 24
+CALL find('wretched');
+heading
+Letter 4
+Chapter 5
+Chapter 7
+Chapter 8
+Chapter 9
+Chapter 10
+Chapter 11
+Chapter 12
+Chapter 15
+Chapter 20
+Chapter 21
+Chapter 24
+CALL find('mariner');
+heading
+Letter 2
+Chapter 5
+SET GLOBAL innodb_ft_aux_table="test/book";
+OPTIMIZE TABLE book;
+Table	Op	Msg_type	Msg_text
+test.book	optimize	status	OK
+CALL find('they');
+heading
+?Letter 1
+Letter 2
+Letter 4
+Chapter 1
+Chapter 2
+Chapter 3
+Chapter 5
+Chapter 6
+Chapter 7
+Chapter 8
+Chapter 9
+Chapter 10
+Chapter 11
+Chapter 12
+Chapter 13
+Chapter 14
+Chapter 15
+Chapter 16
+Chapter 17
+Chapter 18
+Chapter 19
+Chapter 20
+Chapter 21
+Chapter 22
+Chapter 23
+Chapter 24
+CALL find('wretched');
+heading
+Letter 4
+Chapter 5
+Chapter 7
+Chapter 8
+Chapter 9
+Chapter 10
+Chapter 11
+Chapter 12
+Chapter 15
+Chapter 20
+Chapter 21
+Chapter 24
+CALL find('mariner');
+heading
+Letter 2
+Chapter 5
+SET GLOBAL innodb_ft_aux_table="test/book";
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+count(*)
+47753
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+count(*)
+0
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+count(*)
+0
+DELETE FROM book;
+CALL find('they');
+heading
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+count(*)
+28
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+count(*)
+47753
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+count(*)
+0
+OPTIMIZE TABLE book;
+Table	Op	Msg_type	Msg_text
+test.book	optimize	status	OK
+CALL find('they');
+heading
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+count(*)
+28
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+count(*)
+33742
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+count(*)
+0
+SET GLOBAL innodb_ft_num_word_optimize=10000;
+OPTIMIZE TABLE book;
+Table	Op	Msg_type	Msg_text
+test.book	optimize	status	OK
+OPTIMIZE TABLE book;
+Table	Op	Msg_type	Msg_text
+test.book	optimize	status	OK
+CALL find('they');
+heading
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+count(*)
+0
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+count(*)
+0
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+count(*)
+0
+DROP TABLE book;
+DROP PROCEDURE find;
+SET GLOBAL innodb_optimize_fulltext_only=OFF;
+SET GLOBAL innodb_ft_aux_table=default;
+SET GLOBAL innodb_ft_num_word_optimize=default;
diff --git a/mysql-test/suite/innodb_fts/t/optimize_big.test b/mysql-test/suite/innodb_fts/t/optimize_big.test
new file mode 100644
index 00000000000..5b10cb2c462
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/t/optimize_big.test
@@ -0,0 +1,76 @@
+# Test innodb_optimize_fulltext_only optimization on large text
+# Because of the way this optimization is perfomed, some logic is only
+# hit if the size of all individual tokens after compression
+# exceeds a certain threshold
+
+SET GLOBAL innodb_optimize_fulltext_only=ON;
+
+CREATE TABLE book (
+	id INT UNSIGNED AUTO_INCREMENT NOT NULL PRIMARY KEY,
+	heading VARCHAR(20),
+	content TEXT,
+	FULLTEXT idx (content)
+	) ENGINE= InnoDB DEFAULT CHARSET=utf8mb4;
+
+CREATE PROCEDURE find (word CHAR(20))
+	SELECT heading FROM book WHERE MATCH(content)
+		AGAINST (word IN NATURAL LANGUAGE MODE)
+		ORDER BY id;
+
+--replace_result $MYSQLTEST_VARDIR <MYSQLTEST_VARDIR>
+eval
+LOAD DATA INFILE '$MYSQLTEST_VARDIR/std_data/lob/frankenstein.txt' INTO TABLE book CHARACTER SET utf8mb4
+	FIELDS TERMINATED BY '#' LINES TERMINATED BY '@' (heading, content);
+
+CALL find('they');
+CALL find('wretched');
+CALL find('mariner');
+
+SET GLOBAL innodb_ft_aux_table="test/book";
+
+OPTIMIZE TABLE book;
+
+CALL find('they');
+CALL find('wretched');
+CALL find('mariner');
+
+SET GLOBAL innodb_ft_aux_table="test/book";
+
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+
+DELETE FROM book;
+
+CALL find('they');
+
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+
+OPTIMIZE TABLE book;
+
+CALL find('they');
+
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+
+SET GLOBAL innodb_ft_num_word_optimize=10000;
+
+OPTIMIZE TABLE book;
+# Need to run OPTIMIZE TABLE twice because of Bug#35502793
+OPTIMIZE TABLE book;
+
+CALL find('they');
+
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_DELETED;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE;
+SELECT count(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE;
+
+DROP TABLE book;
+DROP PROCEDURE find;
+SET GLOBAL innodb_optimize_fulltext_only=OFF;
+SET GLOBAL innodb_ft_aux_table=default;
+SET GLOBAL innodb_ft_num_word_optimize=default;
diff --git a/storage/innobase/fts/fts0opt.cc b/storage/innobase/fts/fts0opt.cc
index eec6f2cd363..fbe7c035e34 100644
--- a/storage/innobase/fts/fts0opt.cc
+++ b/storage/innobase/fts/fts0opt.cc
@@ -576,27 +576,21 @@ fts_index_fetch_nodes(
 }
 
 /**********************************************************************//**
-Read a word */
+Extract a given number of bytes into a buffer */
 static
-byte*
-fts_zip_read_word(
+bool
+fts_zip_extract_bytes(
 /*==============*/
 	fts_zip_t*	zip,		/*!< in: Zip state + data */
-	fts_string_t*	word)		/*!< out: uncompressed word */
+	byte *buf,				/*!< out: buffer to be filled */
+	unsigned int size) 		/*!< in: size of buffer */
 {
-	short		len = 0;
+	bool complete = false;
+	zip->zp->next_out = buf;
+	zip->zp->avail_out = size;
 	void*		null = NULL;
-	byte*		ptr = word->f_str;
 	int		flush = Z_NO_FLUSH;
 
-	/* Either there was an error or we are at the Z_STREAM_END. */
-	if (zip->status != Z_OK) {
-		return(NULL);
-	}
-
-	zip->zp->next_out = reinterpret_cast<byte*>(&len);
-	zip->zp->avail_out = sizeof(len);
-
 	while (zip->status == Z_OK && zip->zp->avail_out > 0) {
 
 		/* Finished decompressing block. */
@@ -635,22 +629,26 @@ fts_zip_read_word(
 
 		switch (zip->status = inflate(zip->zp, flush)) {
 		case Z_OK:
-			if (zip->zp->avail_out == 0 && len > 0) {
-
-				ut_a(len <= FTS_MAX_WORD_LEN);
-				ptr[len] = 0;
-
-				zip->zp->next_out = ptr;
-				zip->zp->avail_out = len;
-
-				word->f_len = len;
-				len = 0;
+			if (zip->zp->avail_out == 0) {
+				complete = true;
 			}
 			break;
 
-		case Z_BUF_ERROR:	/* No progress possible. */
 		case Z_STREAM_END:
+			if (zip->zp->avail_out == 0) {
+				complete = true;
+			}
+
+			/* Fallthrough */
+		case Z_BUF_ERROR:	/* No progress possible. */
 			inflateEnd(zip->zp);
+			/* All blocks must be freed at end of inflate. */
+			for (ulint i = 0; i < ib_vector_size(zip->blocks); ++i) {
+				if (ib_vector_getp(zip->blocks, i)) {
+					ut_free(ib_vector_getp(zip->blocks, i));
+					ib_vector_set(zip->blocks, i, &null);
+				}
+			}
 			break;
 
 		case Z_STREAM_ERROR:
@@ -659,21 +657,42 @@ fts_zip_read_word(
 		}
 	}
 
-	/* All blocks must be freed at end of inflate. */
+	return complete;
+}
+
+/**********************************************************************//**
+Read a word */
+static
+bool
+fts_zip_read_word(
+/*==============*/
+	fts_zip_t*	zip,			/*!< in: Zip state + data */
+	fts_string_t*	word)		/*!< out: uncompressed word */
+{
+	/* Either there was an error or we are at the Z_STREAM_END. */
 	if (zip->status != Z_OK) {
-		for (ulint i = 0; i < ib_vector_size(zip->blocks); ++i) {
-			if (ib_vector_getp(zip->blocks, i)) {
-				ut_free(ib_vector_getp(zip->blocks, i));
-				ib_vector_set(zip->blocks, i, &null);
-			}
-		}
+		return false;
 	}
 
-	if (ptr != NULL) {
-		ut_ad(word->f_len == strlen((char*) ptr));
+	ushort len = 0;
+
+	const bool have_len =
+		fts_zip_extract_bytes(zip, reinterpret_cast<byte *>(&len), sizeof(len));
+
+	if (!have_len) {
+		return false;
 	}
 
-	return(zip->status == Z_OK || zip->status == Z_STREAM_END ? ptr : NULL);
+	ut_a(len <= FTS_MAX_WORD_LEN);
+
+	word->f_len = len;
+	const bool have_word = fts_zip_extract_bytes(zip, word->f_str, len);
+	ut_ad(have_word);
+
+	word->f_str[len] = 0;
+	ut_ad(word->f_len == strlen((char *)word->f_str));
+
+	return have_word;
 }
 
 /**********************************************************************//**

